/*
 *
 *  ALL03
 *
 *  26.07.2002
 *
 *  by Fabio Sturman
 *
 *  fabio.sturman@tiscali.it
 *
 *  89c2051.h
 *
 *  main module include file
 *
 */

/* Copyright (c) 2002 Fabio Sturman (fabio.sturman@tiscali.it)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#define VERSION_MAIOR 0
#define VERSION_MINOR 1
#define VERSION_PATCH 0

/*- ATMEL 89C2051 Level1--------------------------------------*/


#define NPROG 16
#define RDY   13
#define RST   11
#define XTAL1 15

#define VIL   0
#define VIH   1
#define VPP   2

#define wr_nprog(x) all03_wr_pin(NPROG,x)
#define pulse_nprog_10ms() pulse_nprog_x(10.0)
#define pulse_nprog_1ms() pulse_nprog_x(1.0)
#define wr_rst(x) all03_wr_pin(RST,x)
#define wr_fpm0(x) all03_wr_pin(17,x)
#define wr_fpm1(x) all03_wr_pin(18,x)
#define wr_fpm2(x) all03_wr_pin(19,x)
#define wr_fpm3(x) all03_wr_pin(21,x)
#define rd_rdy() all03_rd_pin(RDY)
#define short_delay() all03_rd_pin(RDY)
#define wr_xtal1(x) all03_wr_pin(XTAL1,x)

/*- ATMEL 89C2051 Level2--------------------------------------*/

#define COMMAND_WRITE_CODE_DATA       0x0e
#define COMMAND_READ_CODE_DATA        0x0c
#define COMMAND_CHIP_ERASE            0x01
#define COMMAND_READ_SIGNATURE_BYTE   0x00
#define COMMAND_WRITE_LOCK_BIT_1      0x0f
#define COMMAND_WRITE_LOCK_BIT_2      0x03

#define PROC_STRING "Insert AT89CX051 and press <ENTER>\n"
#define print_model() printf("Model: AT89C%d051\n", micro_controller_model)
#define print_version() printf("Version %d.%d.%d",VERSION_MAIOR,VERSION_MINOR,VERSION_PATCH)

/*- ATMEL 89CX051 Level1--------------------------------------*/

void wr_data(unsigned char ub);
unsigned char rd_data(void);
void pulse_nprog(void);
void pulse_nprog_x(float x);
void wr_fpm(unsigned char fpm);
void inc_address(void);
int wait_rdy(void);
void chip_init(void);

/*- ATMEL 89CX051 Level2--------------------------------------*/

void edit_model(void);
void print_lock_bits(void);
void edit_lock_bits(void);
void write_lock_bits(void);
void erase(void);
void read_signature(void);
void write(void);
void read(void);
void blank_check(void);
void verify(void);
void display_help(void);
void read_flash_buf_from_file(void);
void write_flash_buf_to_file(void);
void display_help(void);
int main(int argc, char *argv[]);


