/*
 *
 *  ALL03
 *
 *  21.05.2003
 *
 *  by Fabio Sturman
 *
 *  fabio.sturman@tiscali.it
 *
 *  89s52.h
 *
 *  main module include file
 *
 */

/* Copyright (c) 2002, 2003 Fabio Sturman (fabio.sturman@tiscali.it)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/*- AT89S52 Level 1 --------------------------------------*/
#define PIN_MISO_AT89S52  7
#define PIN_RST_AT89S52   9
#define PIN_SCK_AT89S52   8
#define PIN_MOSI_AT89S52  6
#define PIN_VCC_AT89S52   40
#define PIN_CLOCK2_AT89S52 18
#define PIN_CLOCK1_AT89S52 19

#define set_miso(x) all03_wr_pin(pin_miso,x)
#define set_mosi(x) all03_wr_pin(pin_mosi,x)
#define set_sck(x)  all03_wr_pin(pin_sck,x)
#define set_rst(x)  all03_wr_pin(pin_rst,x)
#define set_power() all03_wr_pin(pin_vcc,1); all03_wr_vcc_pin(pin_vcc,1)
#define get_miso()  all03_rd_pin(pin_miso)
#define set_clock() all03_wr_pin(pin_clock2,1); all03_wr_pin(pin_clock1,1); all03_select_f_osc(1); all03_set_osc_18_19(1)

#define CMD_PROGRAMMING_ENABLE_1 M_1010_1100
#define CMD_PROGRAMMING_ENABLE_2 M_0101_0011
#define CMD_CHIP_ERASE_1         M_1010_1100
#define CMD_CHIP_ERASE_2         M_1000_0000
#define CMD_READ_PROGRAM_MEMORY  M_0010_0000
#define CMD_WRITE_PROGRAM_MEMORY M_0100_0000
#define CMD_READ_LOCK_BITS       M_0010_0100
#define CMD_WRITE_LOCK_BITS_1    M_1010_1100
#define CMD_WRITE_LOCK_BITS_2    M_1110_0000
#define CMD_READ_SIGNATURE_BYTES M_0010_1000
#define CMD_READ_PROGRAM_MEMORY_PAGE_MODE  M_0011_0000
#define CMD_WRITE_PROGRAM_MEMORY_PAGE_MODE M_0101_0000

#define ANSWER_PROGRAMMING_ENABLE M_0110_1001

/*- AT89S52 Level 2 --------------------------------------*/
#define print_chip_model() printf("Model: %s\n",chip_model)
#define PROC_STRING "\nINSERT %s on adapter %s and press <Enter>\n",chip_model,adapter_model
#define IS_AT89S52    !strcmp(chip_model,"AT89S52")

/*- AT89S52 Level 1 --------------------------------------*/
/* write read */
unsigned char wr_rd_serial(unsigned char byt);
/* put chip in programming mode */
void chip_init(void);
//void cmd_programming_enable(void);
unsigned char cmd_programming_enable(void);
void cmd_chip_erase(void);
unsigned char cmd_read_program_memory(unsigned short int address);
void cmd_write_program_memory(unsigned short int address, unsigned char data);
unsigned char cmd_read_lock_bits(void);
void cmd_write_lock_bits(int lock_bit_1, int lock_bit_2);
unsigned char cmd_read_signature_bytes(unsigned short int address);
int wait_rdy_program(unsigned short int address, unsigned char data);

/*- AT89S52 Level 2 --------------------------------------*/
void edit_chip_model(void);
void display_lock_bits(void);
void edit_lock_bits(void);
void read_lock_bits(void);
void write_lock_bits(void);
void chip_erase(void);
void read_signature_bytes(void);
void write_program_memory(void);
void read_program_memory(void);
void blank_check_program_memory(void);
void verify_program_memory(void);
void read_program_memory_buffer_from_file(void);
void write_program_memory_buffer_to_file(void);
void display_help(void);
int main(int argc, char *argv[]);

